pipeline {
    agent any
    tools {
        nodejs 'node'
    }
    stages {
        stage('Build') {
            steps {
                sh 'ls -la'
                sh 'node -v && npm -v'
                sh 'ls -la'
                sh 'npm install --prefix build/src'
                sh 'npm run build --prefix build/src'
                sh 'ls -la build/src/client/dist'
                sh 'cp -R build/src/client/src/assets/semantic build/src/client/dist/css/'
                sh 'cp build/src/client/src/assets/html/login.jsx build/src/client/dist/html/'
                sh 'rm -rf build/src/client/src/'
                sh 'rm -rf build/src/client/dist_dev/'
                sh 'ls -la build/src'
                sh 'ls -la build/src/client/'
                sh 'ls -la build/src/client/dist/'
                sh 'cat build/src/client/dist/html/index.html'
            }
        }
    }
}

node {
  def commitHash = checkout(scm).GIT_COMMIT
  dir("build/") {
    docker.withTool("docker") {
      // Section with docker registry address
      docker.withRegistry('https://registry.jcpenney.griddynamics.net') {
          env.PATH = "${tool 'docker'}/bin:${env.PATH}"
          // Image name
          def newApp = docker.build("cloud-ops-web-localhost:${env.BRANCH_NAME}-${new Date().format('yyyyMMdd')}-${env.BUILD_NUMBER}")
          // Version name is same with branch name
          def version = "${env.BRANCH_NAME}-${new Date().format('yyyyMMdd')}-${env.BUILD_NUMBER}"
          newApp.push(version)
          sh "docker rmi --force cloud-ops-web:${env.BRANCH_NAME}-${new Date().format('yyyyMMdd')}-${env.BUILD_NUMBER}"
      }
    }

  }
}
